//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "MainFrm.h"
//#include "inp.h"
//#include "out.h"
//#include "lex.h"
#include "stat0.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TMainForm *MainForm;
//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------

String TMainForm::GetInpText () /* vstupni text */
{
   return InpMemo->Lines->Text;
}

String TMainForm::GetInpLine (int num) /* jedna vstupni radka */
{
   return InpMemo->Lines->Strings [num-1];
}

//---------------------------------------------------------------------------

void TMainForm::ClearOutLines () /* vymaz vystupni okno */
{
   OutMemo->Lines->Clear ();
}

void TMainForm::ShowOutLine (String txt) /* pridej vystupni radku */
{
   OutMemo->Lines->Append (txt);
}

//---------------------------------------------------------------------------

void TMainForm::SetTitle (String txt) /* nadpis okna */
{
   this->Caption = "Compiler 0.3 - " + txt;
}

void TMainForm::SetStatus (String txt) /* text ve stavove radce */
{
   StatusBar->SimpleText = txt;
}

//---------------------------------------------------------------------------

void TMainForm::ShowError (String txt)
{
   CloseInp (); /* uzavri vstup a vystup */
   CloseOut ();

   SetStatus ("Line: " + IntToStr (InpLineNum) + " " +
              "Col: " + IntToStr (InpColNum) + " " +
              "Error: " + txt);

   InpMemo->SelStart = InpPos-1; /* pozice kurzoru ve vstupnim okenku */
   InpMemo->SelLength = 1;

   MessageDlg (txt, mtError, TMsgDlgButtons() << mbOK , 0); /* dialogovy box */

   throw EAbort (txt); /* skok zpet do funkce Compile */
}

void TMainForm::Compile ()
{
   try
   {
      OpenInp ();  /* otevri vstupni a vystupni text */
      OpenOut ();
      InitLex ();  /* inicializace modulu Lex, precteni prvniho symbolu */

      while (sy!=EOS)
      {
         statement ();
      }

      CloseInp (); /* uzavri vstupni a vystupni text */
      CloseOut ();
      SetStatus ("O.K."); /* stavova radka */
   }
   catch (EAbort & e)
   {
      /* nic - informace o chybe jiz zobrazila funkce ShowError */
   }
}

//---------------------------------------------------------------------------

void __fastcall TMainForm::FormCreate (TObject *Sender)
{
   /* pri startu otevri soubor */
   String fname = "Test.inp";
   InpMemo->Lines->LoadFromFile (fname);
   SetTitle (fname);
}

//---------------------------------------------------------------------------

void __fastcall TMainForm::MenuOpenClick (TObject *Sender)
{
   if (OpenDialog->Execute())
   {
      InpMemo->Lines->LoadFromFile (OpenDialog->FileName);
      SetTitle (OpenDialog->FileName);
   }
}

void __fastcall TMainForm::MenuSaveClick (TObject *Sender)
{
   if (SaveDialog->Execute())
   {
      InpMemo->Lines->SaveToFile (SaveDialog->FileName);
      SetTitle (SaveDialog->FileName);
   }
}

void __fastcall TMainForm::MenuRunClick (TObject *Sender)
{
   Compile ();
}

void __fastcall TMainForm::MenuExitClick (TObject *Sender)
{
   Close ();
}

//---------------------------------------------------------------------------

void __fastcall TMainForm::MenuUndoClick (TObject *Sender)
{
   InpMemo->Undo ();
}

void __fastcall TMainForm::MenuCutClick (TObject *Sender)
{
   InpMemo->CutToClipboard ();
}

void __fastcall TMainForm::MenuCopyClick (TObject *Sender)
{
   InpMemo->CopyToClipboard ();
}

void __fastcall TMainForm::MenuPasteClick (TObject *Sender)
{
   InpMemo->PasteFromClipboard ();
}

void __fastcall TMainForm::MenuDeleteClick (TObject *Sender)
{
   InpMemo->ClearSelection ();
}

//---------------------------------------------------------------------------

